#include <windows.h>
#include <stdio.h>
#include "jdesk.h"
#include "../../litestep/lsapi/lsapi.h"

const char rcsRevision[] = TEXT("$Revision: 0.61 $"); // Our Version 
const char rcsId[] = TEXT("$Id: jdesk.cpp, v0.61 2000/02/02 00:22:00 jugg $"); // The Full RCS ID.
const char szAppName[] = TEXT("DesktopBackgroundClass"); // Our window class, etc

HWND hMainWnd; // main window handle
HWND parent; // LS window handle

char lsPath[256];

jDeskSettings jds;

HINSTANCE dll;
//MINIMIZEDMETRICS mm;
BOOL IsFirst = TRUE;
BOOL IsRezChange = FALSE;
int screenWidth, screenHeight;
int waLeft=0, waRight=0, waTop=0, waBottom=0;
int waLeftBk, waRightBk, waTopBk, waBottomBk;
// theres gotta be a better way to do this
char *b1Down = new char[MAXLEN], *b1Up = new char[MAXLEN], *b2Down = new char[MAXLEN], *b2Up = new char[MAXLEN], *b3Down = new char[MAXLEN], *b3Up = new char[MAXLEN];
char *b1DownCtrl = new char[MAXLEN], *b1UpCtrl = new char[MAXLEN], *b2DownCtrl = new char[MAXLEN], *b2UpCtrl = new char[MAXLEN], *b3DownCtrl = new char[MAXLEN], *b3UpCtrl = new char[MAXLEN];
char *b1DownShift = new char[MAXLEN], *b1UpShift = new char[MAXLEN], *b2DownShift = new char[MAXLEN], *b2UpShift = new char[MAXLEN], *b3DownShift = new char[MAXLEN], *b3UpShift = new char[MAXLEN];

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
void Button1(WPARAM, UINT);
void Button2(WPARAM, UINT);
void Button3(WPARAM, UINT);
void SetWorkArea(void);
void ResetWorkArea(void);
void JDeskSetWorkArea(HWND, char *);
void JDeskResetWorkArea(void);
void ProcessCommand(char *, char *, char *);
void CreateMButtons(char *, char *, char *);

void CreateMButtons(char *button, char *bdown, char *bup)
{
	int count,i;
	char buffer[4096];
	char *tokens[2];

	VarExpansion(buffer, button);
	count = CommandTokenize(buffer, NULL, 0, NULL);
	for(i=0;i<count&&i<2;i++)
		tokens[i] = new char[MAXLEN];
	if (count < 3 && count > 0)
	{
		if (CommandTokenize(buffer, tokens, count, NULL))
		{
			switch (count)
			{
				case 1:
					strcpy(bup, tokens[0]);
					break;
				case 2:
					strcpy(bdown, tokens[0]);
					strcpy(bup, tokens[1]);
					break;
				default:
					break;
			}
		}
	}
	for(i=0;i<count&&i<2;i++)
		delete [] tokens[i];
	return;
}

void ProcessCommand(char *button, char *bdown, char *bup)
{
	int str1='[';
	int str2=']';

	strcpy(bdown, TEXT(""));
	strcpy(bup, TEXT(""));

	if(strchr(button, str1) != NULL || strchr(button, str2) != NULL)
		CreateMButtons(button, bdown, bup);
	else
		strcpy(bup, button);
	return;
}

jDeskSettings ReadSettings()
{
	jDeskSettings settings;
	char tmp[MAXLEN];
	char *token;

	GetRCLine(TEXT("jDeskMButton1"), settings.MButton1, MAXLEN, TEXT(""));
		ProcessCommand(settings.MButton1, b1Down, b1Up);

	GetRCLine(TEXT("jDeskMButton2"), settings.MButton2, MAXLEN, TEXT(""));
		ProcessCommand(settings.MButton2, b2Down, b2Up);

	GetRCLine(TEXT("jDeskMButton3"), settings.MButton3, MAXLEN, TEXT(""));
		ProcessCommand(settings.MButton3, b3Down, b3Up);

	GetRCLine(TEXT("jDeskCtrlMButton1"), settings.CtrlMButton1, MAXLEN, TEXT(""));
		ProcessCommand(settings.CtrlMButton1, b1DownCtrl, b1UpCtrl);

	GetRCLine(TEXT("jDeskCtrlMButton2"), settings.CtrlMButton2, MAXLEN, TEXT(""));
		ProcessCommand(settings.CtrlMButton2, b2DownCtrl, b2UpCtrl);

	GetRCLine(TEXT("jDeskCtrlMButton3"), settings.CtrlMButton3, MAXLEN, TEXT(""));
		ProcessCommand(settings.CtrlMButton3, b3DownCtrl, b3UpCtrl);

	GetRCLine(TEXT("jDeskShiftMButton1"), settings.ShiftMButton1, MAXLEN, TEXT(""));
		ProcessCommand(settings.ShiftMButton1, b1DownShift, b1UpShift);

	GetRCLine(TEXT("jDeskShiftMButton2"), settings.ShiftMButton2, MAXLEN, TEXT(""));
		ProcessCommand(settings.ShiftMButton2, b2DownShift, b2UpShift);

	GetRCLine(TEXT("jDeskShiftMButton3"), settings.ShiftMButton3, MAXLEN, TEXT(""));
		ProcessCommand(settings.ShiftMButton3, b3DownShift, b3UpShift);

	settings.DisableMButton3 = GetRCBool(TEXT("jDeskDisableMButton3"), TRUE);
	//settings.HideMinAppBar = GetRCBool(TEXT("jDeskHideMinAppBar"), TRUE);
	settings.WorkArea = GetRCBool(TEXT("jDeskWorkArea"), TRUE);

	GetRCString(TEXT("jDeskDesktopFolder"), settings.DesktopFolder, TEXT(""), MAX_PATH);
	GetRCString(TEXT("jDeskWorkArea"), tmp, TEXT("0,0,0,0"), MAXLEN);
	token = strtok(tmp, TEXT(" ,"));
		if (token != NULL)
			waLeft = atoi(token);
	token = strtok(NULL, TEXT(" ,"));
		if (token != NULL)
			waRight = atoi(token);
	token = strtok(NULL, TEXT(" ,"));
		if (token != NULL)
			waTop = atoi(token);
	token = strtok(NULL, TEXT(" ,"));
		if (token != NULL)
			waBottom = atoi(token);
	waLeftBk = waLeft;
	waRightBk = waRight;
	waTopBk = waTop;
	waBottomBk = waBottom;
	return settings;
}

int initModuleEx(HWND parentWnd, HINSTANCE dllInst, LPCSTR szPath/*, BOOL gRecycle*/)
{
	WNDCLASS wc;
	UINT Msgs[2];

	dll = dllInst;
	parent = parentWnd;
	strcpy (lsPath, szPath);

	screenWidth = GetSystemMetrics(SM_CXSCREEN);
	screenHeight = GetSystemMetrics(SM_CYSCREEN);

	jds = ReadSettings();

	// Set the work area for maximized applications
	SetWorkArea();
	IsFirst = FALSE;

	{// Register the jDesk desktop window class
		memset(&wc,0,sizeof(wc));
		wc.hCursor = LoadCursor(NULL, IDC_ARROW);
		wc.lpfnWndProc = WndProc;				// our window procedure
		wc.hInstance = dllInst;					// hInstance of DLL
		wc.lpszClassName = szAppName;		// our window class name
		wc.style = 0;
		if (!RegisterClass(&wc))
		{
			MessageBox(parent,TEXT("Error registering window class"),TEXT("jDesk"),MB_OK);
			return 1;
		}
	}
	{// Create jDesk desktop window
		hMainWnd = CreateWindowEx(
			WS_EX_TOOLWINDOW,				// exstyles 
			szAppName,										// our window class name
			TEXT(""),										// use description for a window title
			WS_POPUP|WS_CLIPSIBLINGS|WS_CLIPCHILDREN,
			0, 0,											// position 
			screenWidth,screenHeight,						// width & height of window
			parent,											// parent window 
			NULL,											// no menu
			dll,											// hInstance of DLL
			NULL);											// no window creation data
		if (!hMainWnd)
		{
			MessageBox(parent,TEXT("Error creating window"),TEXT("jDesk"),MB_OK);
			return 1;
		}
	}

	AddBangCommand(TEXT("!JDESKSETWORKAREA"),JDeskSetWorkArea);
	AddBangCommand(TEXT("!JDESKRESETWORKAREA"),JDeskResetWorkArea);

	{//register message for version info
		Msgs[0] = LM_GETREVID;
		Msgs[1] = 0;
		SendMessage(parent, LM_REGISTERMESSAGE, (WPARAM) hMainWnd, (LPARAM) Msgs);
	}

	//memset(&mm, 0, sizeof(MINIMIZEDMETRICS));
	//mm.cbSize = sizeof(MINIMIZEDMETRICS);
	//SystemParametersInfo(SPI_GETMINIMIZEDMETRICS, sizeof(MINIMIZEDMETRICS), &mm, FALSE);
	//if (!gRecycle || (gRecycle && !jds.HideMinAppBar))
	//{
	//	mm.iArrange = ARW_BOTTOMLEFT|ARW_RIGHT;
	//	SystemParametersInfo(SPI_SETMINIMIZEDMETRICS, sizeof(MINIMIZEDMETRICS), &mm, SPIF_SENDCHANGE);
	//	ArrangeIconicWindows(GetDesktopWindow());
	//}
	//Final desktop window settings and display
	if (GetFileAttributes(jds.DesktopFolder) != 0xFFFFFFFF)
		DragAcceptFiles(hMainWnd, TRUE);
	SetWindowLong(hMainWnd, GWL_USERDATA, 0x49474541);
	SetWindowPos(hMainWnd, HWND_BOTTOM, 0, 0, 0, 0, SWP_NOSIZE|SWP_NOMOVE);
	ShowWindow(hMainWnd,SW_SHOWNORMAL);
	SetActiveWindow(hMainWnd);

	//if (jds.HideMinAppBar)
	//{
	//	mm.iArrange |= 8; //ARW_HIDE; // ARW_HIDE == 8
	//	SystemParametersInfo(SPI_SETMINIMIZEDMETRICS, sizeof(MINIMIZEDMETRICS), &mm, SPIF_SENDCHANGE);
	//}
	return 0;
}

void quitModule(HINSTANCE dllInst/*, BOOL gRecycle*/)
{ 
	UINT Msgs[2];
//	if (!gRecycle && jds.HideMinAppBar)
//	{
//		ResetWorkArea();
//		mm.iArrange = ARW_BOTTOMLEFT|ARW_RIGHT;
//		SystemParametersInfo(SPI_SETMINIMIZEDMETRICS, sizeof(MINIMIZEDMETRICS), &mm, SPIF_SENDCHANGE);
//		ArrangeIconicWindows(GetDesktopWindow());
//	}

	Msgs[0] = LM_GETREVID;
	Msgs[1] = 0;
	SendMessage(parent, LM_UNREGISTERMESSAGE, (WPARAM) hMainWnd, (LPARAM) Msgs);

	RemoveBangCommand(TEXT("!JDESKSETWORKAREA"));
	RemoveBangCommand(TEXT("!JDESKRESETWORKAREA"));

	DestroyWindow(hMainWnd); // delete jDesk desktop window
	UnregisterClass(szAppName,dllInst); // unregister jDesk desktop window class
	return;
}

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case LM_GETREVID:
			{
				char *buf = (char *) lParam;

				if (wParam == 0)
				{
					strcpy(buf, TEXT("jdesk.dll: "));
					strcat(buf, &rcsRevision[11]);
					buf[strlen(buf)-1] = '\0';
				}
				else if (wParam == 1)
				{
					strcpy(buf, &rcsId[1]);
					buf[strlen(buf)-1] = '\0';
				}
				else
					strcpy(buf, TEXT(""));
				return strlen(buf);
			}
		case WM_DISPLAYCHANGE:
			{// Screen resolution has changed. Update stored settings and resize desktop window.
				IsRezChange = TRUE;
				SetWindowPos(hMainWnd, HWND_BOTTOM, 0, 0, LOWORD(lParam), HIWORD(lParam), NULL);
				screenWidth = LOWORD(lParam); 
				screenHeight = HIWORD(lParam);
				SetWorkArea();
				return 0;
			}
		case WM_DROPFILES:
			{// need to implement CTRL-copy, SHIFT-move, CTRL+SHIFT-shortcut modifier keys
				char szFullFileName[MAX_PATH];
				char szFileName[MAX_PATH];
				char buffer[MAX_PATH];
				int numFiles;
				numFiles = DragQueryFile((HDROP)wParam, 0xFFFFFFFF, NULL, NULL);
				for (int i=0;i<numFiles;i++)
				{
					DragQueryFile((HDROP)wParam, i, szFullFileName, sizeof(szFullFileName));
					GetFileTitle(szFullFileName, szFileName, sizeof(szFileName));
					strcpy(buffer, jds.DesktopFolder);
					if (buffer[strlen(buffer)-1] != '\\')
						strcat(buffer, TEXT("\\"));
					strcat(buffer, szFileName);
					if (GetFileAttributes(szFullFileName) != 0xFFFFFFFF)
					{
						if (!CopyFile(szFullFileName, buffer, TRUE))
							if (MessageBox(NULL, TEXT("File already exists. Overwrite?"), buffer, MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON1|MB_SYSTEMMODAL) == IDYES)
								if (!CopyFile(szFullFileName, buffer, FALSE))
									MessageBox(NULL, TEXT("Operation Failed!"), TEXT("ERROR!"), MB_OK|MB_ICONERROR|MB_DEFBUTTON1|MB_SYSTEMMODAL);
					}
					else // not really sure why this would happen, but you never know what crazy things go on in your computer!
						MessageBox(NULL, TEXT("File does not exist!"), TEXT("ERROR!"), MB_OK|MB_ICONERROR|MB_DEFBUTTON1|MB_SYSTEMMODAL);
				}
				DragFinish((HDROP)wParam);
				return 0;
			}
		case WM_ENDSESSION:
		case WM_QUERYENDSESSION:
			return SendMessage(parent,message,wParam,lParam);
		case WM_ERASEBKGND:
			{
				PaintDesktop((HDC)wParam);
				return 1;
			}
		case WM_SYSCOMMAND:
			{
				switch (wParam)
				{
					case SC_CLOSE://For using the standard alt+F4 to shutdown windows
						ParseBangCommand(hMainWnd, TEXT("!ShutDown"), NULL); // could actually just forward on, since LiteStep checks for this message as well, but this is safer.
						return 0;
					default:
						break;
				}
				break;
			}
		case WM_KEYDOWN:
		case WM_KEYUP: // forward
				PostMessage(parent,message,wParam,lParam);
			return 0;
		case WM_HOTKEY:
				PostMessage(parent,message,wParam,lParam);
		case WM_WINDOWPOSCHANGING:
			{
				if (!IsRezChange){
					// Trap windowposchanging messages
					WINDOWPOS *c = (WINDOWPOS*)lParam;
					c->hwndInsertAfter = HWND_BOTTOM;
					c->flags |= SWP_NOMOVE|SWP_NOSIZE;
					return 0;
				}else{
					IsRezChange = FALSE;
				}
				break;
			}
		case WM_LBUTTONDOWN:
		case WM_LBUTTONUP:
			{
				Button1(wParam, message);
				return 0;
			}
		case WM_MBUTTONDOWN:
		case WM_MBUTTONUP:
			{
				if (jds.DisableMButton3)
					break;
				Button3(wParam, message);
				return 0;
			}
		case WM_RBUTTONDOWN:
		case WM_RBUTTONUP:
			{
				Button2(wParam, message);
				return 0;
			}
	}
	return DefWindowProc(hwnd,message,wParam,lParam);
}

void Button1(WPARAM wParam, UINT message)
{
	if (wParam & MK_LBUTTON)
		wParam = wParam ^ MK_LBUTTON;
	switch(message)
	{
		case WM_LBUTTONDOWN:
			{
				switch(wParam)
				{
					case MK_CONTROL:
						LSExecute(hMainWnd, b1DownCtrl, 0);
						break;
					case MK_SHIFT:
						LSExecute(hMainWnd, b1DownShift, 0);
						break;
					default:
						LSExecute(hMainWnd, b1Down, 0);
						break;
				}
				break;
			}
		case WM_LBUTTONUP:
			{
				switch(wParam)
				{
					case MK_CONTROL:
						LSExecute(hMainWnd, b1UpCtrl, 0);
						break;
					case MK_SHIFT:
						LSExecute(hMainWnd, b1UpShift, 0);
						break;
					default:
						LSExecute(hMainWnd, b1Up, 0);
						break;
				}
				break;
			}
	}
	return;
}

void Button3(WPARAM wParam, UINT message)
{
	if (wParam & MK_MBUTTON)
		wParam = wParam ^ MK_MBUTTON;
	switch(message)
	{
		case WM_MBUTTONDOWN:
			{
				switch(wParam)
				{
					case MK_CONTROL:
						LSExecute(hMainWnd, b3DownCtrl, 0);
						break;
					case MK_SHIFT:
						LSExecute(hMainWnd, b3DownShift, 0);
						break;
					default:
						LSExecute(hMainWnd, b3Down, 0);
						break;
				}
				break;
			}
		case WM_MBUTTONUP:
			{
				switch(wParam)
				{
					case MK_CONTROL:
						LSExecute(hMainWnd, b3UpCtrl, 0);
						break;
					case MK_SHIFT:
						LSExecute(hMainWnd, b3UpShift, 0);
						break;
					default:
						LSExecute(hMainWnd, b3Up, 0);
						break;
				}
				break;
			}
	}
	return;
}

void Button2(WPARAM wParam, UINT message)
{
	if (wParam & MK_RBUTTON)
		wParam = wParam ^ MK_RBUTTON;
	switch(message)
	{
		case WM_RBUTTONDOWN:
			{
				switch(wParam)
				{
					case MK_CONTROL:
						LSExecute(hMainWnd, b2DownCtrl, 0);
						break;
					case MK_SHIFT:
						LSExecute(hMainWnd, b2DownShift, 0);
						break;
					default:
						LSExecute(hMainWnd, b2Down, 0);
						break;
				}
				break;
			}
		case WM_RBUTTONUP:
			{
				switch(wParam)
				{
					case MK_CONTROL:
						LSExecute(hMainWnd, b2UpCtrl, 0);
						break;
					case MK_SHIFT:
						LSExecute(hMainWnd, b2UpShift, 0);
						break;
					default:
						LSExecute(hMainWnd, b2Up, 0);
						break;
				}
				break;
			}
	}
	return;
}

void SetWorkArea(void)
{
	RECT r;
	if (!(waLeft || (waRight && waRight != screenWidth) || waTop || (waBottom && waBottom != screenHeight)))
		jds.WorkArea = FALSE;  // don't need this, but just cuts back on unnecessary code execution. (or adds extra, depends on how you look at it :)
	if (jds.WorkArea)
	{
		r.top = 0;
		r.left = 0;
		r.bottom = screenHeight;
		r.right = screenWidth;
		int minSize = 200;//Allowing a minimum of 200x200 work area. Anything less is even more rediculous then that, plus impossible to access a max'd window.
		r.left = waLeft<0 ? screenWidth+waLeft:waLeft;
			if (r.left >= screenWidth-minSize) r.left = 0;

		r.right = waRight<0 ? screenWidth+waRight:waRight;
			if (r.right <= r.left+minSize) r.right = screenWidth;

		r.top = waTop<0 ? screenHeight+waTop:waTop;
			if (r.top >= screenHeight-minSize) r.top = 0;

		r.bottom = waBottom<0 ? screenHeight+waBottom:waBottom;
			if (r.bottom <= r.top+minSize) r.bottom = screenHeight;
	}
	SystemParametersInfo(SPI_SETWORKAREA,(IsFirst ? 0:1),(jds.WorkArea ? &r:NULL),SPIF_SENDCHANGE);
	return;
}

void ResetWorkArea(void)
{
	SystemParametersInfo(SPI_SETWORKAREA,0,NULL,SPIF_SENDCHANGE);
	return;
}

void JDeskSetWorkArea(HWND caller, char *args)
{
	caller=caller;
	if (!args) return;
	jds.WorkArea = TRUE;

	args = strtok(args, TEXT("\" ,"));
		if (args != NULL)
			waLeft = atoi(args);
	args = strtok(NULL, TEXT("\" ,"));
		if (args != NULL)
			waRight = atoi(args);
	args = strtok(NULL, TEXT("\" ,"));
		if (args != NULL)
			waTop = atoi(args);
	args = strtok(NULL, TEXT("\" ,"));
		if (args != NULL)
			waBottom = atoi(args);
	SetWorkArea();
	return;
}

void JDeskResetWorkArea(void)
{
	waLeft=waLeftBk;
	waRight=waRightBk;
	waTop=waTopBk;
	waBottom=waBottomBk;
	SetWorkArea();
	return;
}
